-module(action_transfer).
%%-author('Andrey Martemyanov').

-include_lib("nitro/include/nitro.hrl").

-export([
  render_action/1
]).


render_action(Record) ->
  case Record#transfer.state of
    undefined -> ok;
    List when erlang:is_list(List) -> [ erlang:put(K, V) || {K, V} <- List ];
    Single -> erlang:put(state, Single)
  end,
  Events = case Record#transfer.events of
    E when erlang:is_list(E) -> E;
    E -> [E]
  end,
  [ self() ! M || M <- Events ],
  ok.

